function writepo4;

% edit for your path
base_path = '/work_O1/smomw069/MIT2.8/SetupMatrix';
addpath('/work_O1/smomw069/bin/mexnc')

% edit for your desired in- and output file name
netcdffilename = 'po4mean_woa1x1annual_analysed_to_mit2.8_full.cdf'
petscfilename = 'po4annual.petsc'

% edit for your desired / netCDF provided variable name
po4=getnc(netcdffilename,'OBS',-1,-1,-1,[3 2 1]);

% see TMM documentation on how to obtain and use these files
gridFile=fullfile(base_path,'grid_xyz');
load(gridFile,'nx','ny','nz','dz','dznom','x','y','z')

boxFile=fullfile(base_path,'boxes');
load(boxFile,'Xboxnom','Yboxnom','Zboxnom','ixBox','iyBox','izBox','nb','volb')

Ib=find(izBox(1,:)==1)';
nbb=length(Ib);
for is=1:nbb
ibs=Ib(is);
Ip{is}=find(Xboxnom==Xboxnom(ibs) & Yboxnom==Yboxnom(ibs));
[zp,izp]=sort(Zboxnom(Ip{is}));
Ip{is}=Ip{is}(izp);
end
Ir=cat(1,Ip{:});
po4b=gcm2matrix(po4,[1:nb]',ixBox,iyBox,izBox);
po4br=po4b(Ir);
writePetscBin(petscfilename,po4br);
